import os
import sys
import time
from pathlib import Path
from Cython.Build import cythonize
from setuptools import setup, Extension, find_packages
import shutil
try:
    import pipwin
except ImportError:
    if(os.name == "nt"):
        os.system("pip install pipwin && pipwin install pyaudio")
    elif(os.name == "posix"):
        os.system("apt-get install python-pyaudio python3-pyaudio")

if(os.name == "nt"):
    program_path = "/".join(os.path.abspath(__file__).split("\\")[:len(os.path.abspath(__file__).split("\\"))-1])
else:
    program_path = "/".join(os.path.abspath(__file__).split("/")[:len(os.path.abspath(__file__).split("/"))-1])
program_files = [program_path + val.replace("\\", "/")[1:] for sublist in [[os.path.join(i[0], j) for j in i[2]] for i in os.walk('./')] for val in sublist]

package_requirement_linux = ["numpy", "psutil", "cython", "requests", "uuid1", "uuid"]
package_requirement_windows = ["numpy", "psutil", "cython", "requests", "wmi", "uuid1", "uuid"]

#if("install" in sys.argv and os.name == "nt"):
    #os.system("pip install pipwin")

setup(
    name='tcpxshell',
    maintainer="Drakeo",
    maintainer_email="obfuscate@riseup.net",
    author="Drakeo",
    author_email="obfuscate@riseup.net",
    install_requires=package_requirement_windows if(os.name == "nt") else package_requirement_linux,
    long_description=open(program_path + "/README.md", "r").read(),
    license='MIT',
    description="TCP Socket Shell over Secure Communication",
    url="https://github.com/ObfuscationNT/tcpxshell",
    ext_modules=[
        Extension('tcpxshell.Backend.handler', [program_path + "/tcpxshell/Backend/handler.pyx"]),
        Extension('tcpxshell.Backend.network', [program_path + "/tcpxshell/Backend/network.pyx"]),
        #Extension("tcpxshell.Network.communication", [program_path + "/tcpxshell/Network/communication.pyx"]),
        #Extension("tcpxshell.Network.handler", [program_path + "/tcpxshell/Network/handler.pyx"]),
        #Extension("tcpxshell.Network.channel", [program_path + "/tcpxshell/Network/channel.pyx"]),
        #Extension("tcpxshell.Network.profile", [program_path + "/tcpxshell/Network/profile.pyx"]),
        #Extension("tcpxshell.Network.server", [program_path + "/tcpxshell/Network/server.pyx"]),
        #Extension("tcpxshell.Network.user", [program_path + "/tcpxshell/Network/user.pyx"])
    ],
    package_data={
        "": ["*.pyd", "*.json", "*.cfg", "version.txt"]
    },
    include_package_data=True,
    version=open(program_path + "/version.txt", "r").read()
)

sizeof_project = sum(p.stat().st_size for p in Path(program_path).rglob('*'))
total_files = len(program_files)

main, revision, tfiles, sproj = [int(retval) for retval in open(program_path + "/version.txt", "r").read().split(".")]

main = main + 1 if(revision > 99) else main
revision = revision + 1 if(revision < 99) else 0


open(program_path + "/version.txt", "w").write("%d.%d.%d.%d" % (main, revision, total_files, sizeof_project))

print("project total size: %dKb" % (sizeof_project // 1024))
print("total project files: %d" % (total_files))
print("main, revision: %d.%d" % (main, revision))
